/*
  CREATURE.H
  ERKKI-enginen inventoryrutiinit (eli siis esinevarastot)

  Versio 0.8.5

  Tarmo Korpela 2005
*/

#ifndef ERKKI_CREATURE_H_
# define ERKKI_CREATURE_H_

/* Yleiset funktiot */

signed int ERKKI_MaxCreature();
signed int CreatureHandle(KENTTA *, unsigned int);
signed int FindFreeCreatureHandle(KENTTA *);
signed int WhatCreaturePalette(unsigned int);
signed int WhoInCreaturePalette(unsigned int);
void RemoveCreature(KENTTA *, signed int);
void DeleteCreature(KENTTA *, signed int);
int ERKKI_getcreature(KENTTA *, int, int);
signed int GetCreatureByName(char *);
int CopyCreature(KENTTA *, CREATURESTACK *, CREATURESTACK *);
/* Makro */ #define CopyCreatureFromMap(f, k, m) CopyCreature(&f->Oliot[k], m);
/* Makro */ #define CopyCreatureToMap(f, k, m) CopyCreature(m, &f->Oliot[k]);

/* Initialisoinnit ja poistamiset */

signed int ERKKI_install_creaturepalette(CREATUREPALETTE *, size_t);
/* Makro */ #define ERKKI_install_creature(cp) ERKKI_install_creaturepalette(cp, sizeof(cp))
signed int ERKKI_release_creaturepalettes();
int ERKKI_init_creature_(signed int, signed int *, size_t, INVENTORYCLASS *);
/* Makro */ #define ERKKI_init_creature(k, ff, ii) ERKKI_init_creature_(k, ff, sizeof(ff), ii)
int ERKKI_free_creature(signed int);

/* Nimist */

char * CreatureNameByLoc(KENTTA *, signed int, signed int);
char * CreatureNameByHandle(KENTTA *, signed int);
char * CreatureNameByType(signed int);

/* Olioiden liikuttaminen/muokkaus/tutkiminen */

int MoveCreature(KENTTA *, signed int, signed int, signed int);
int PosCreature(KENTTA *, signed int, signed int, signed int);
int CreaturePos(KENTTA *, signed int, signed int *, signed int *);
int StepCreature(KENTTA *, signed int);
int StepCreatures(KENTTA *);
int PutCreatureToMap(KENTTA *, signed int, signed int, signed int);

int ModifyCreature(KENTTA *, signed int, int, int, signed int, int);
signed int EquipCreature(KENTTA *, signed int, signed int, char, int);
signed int DamageCreature(KENTTA *, signed int, signed int);
signed int ExHaustCreature(KENTTA *, signed int, signed int);
int AddStepCreature(KENTTA *, signed int, char);
int SetStepCreature(KENTTA *, signed int, char *);

int CreatureData(KENTTA *, signed int, int, int, int);
signed int BasicItemLink(KENTTA *, signed int, signed int, signed int*);

/* Olioiden kerys taulukkoon */

int ERKKI_GetCreatures(KENTTA *, signed int, signed int, signed int, signed int, signed int *, int);
int ERKKI_GetCreatures_ring(KENTTA *, signed int, signed int, signed int, signed int *, int);

/* Tiedostonksittely */
int ERKKI_writecreature(signed int, FILE *);
signed int ERKKI_write_single_creature(KENTTA *, CREATURESTACK *, FILE *);
int ERKKI_readcreature(signed int, FILE *);
signed int ERKKI_read_single_creature(KENTTA *, CREATURESTACK *, FILE *);

#endif /* ERKKI_CREATURE_H_ */