/*
  ERKKI 0.8.5
  TARMO KORPELA
  takorpel@cc.joensuu.fi
  C-tiedosto
*/

#include "erkki.h" //rakenteet ym

/* C++ -ymprist? Koska kaikki on puhdasta C:t, laitetaan koko paketti sulkuihin. */
#ifdef __cplusplus
extern "C" {
#endif

unsigned int engine_dat; //enginen liput

//Tmn saa vaihtaa toiseen jos (vlttmtt) haluaa
static char * EMPTY_STRING = "";

//aktivoitavat tapahtumat
struct ACTIVATECLASS * ERKKI_Aktivoi;
//ansat
struct TRAPCLASS * ERKKI_Ansat;

OBJECTCLASS * ERKKI_Objektit;

/*
  Nauhoittajafunktio, tmn avulla voidaan seurata enginen tapahtumia.
  Parametrit ovat tapahtuma, listieto (2x).
*/
int (* ERKKI_Recorder)(signed int, signed int, signed int);


/*
  Yleiset rutiinit (ei-enginepohjaiset)
*/

//doble-tyypin abs
double d_abs(double x){
  if( x < 0 )return 0 - x; else return x;
}

/* Laskee kertoimet viivalle. Ei kenties nopein, mutta hl'sen'vl - se toimii */
void count_angle_move(double x1, double y1, double x2, double y2, double *xm, double *ym){
  if(x1==x2 && y1==y2){*xm=0;*ym=0;return;}
  if(d_abs(x1-x2) != 0 && d_abs(y1-y2) != 0 ){ /* tys vinoviiva */
    if(d_abs(x1-x2) > d_abs(y1-y2)){
      if(x2>x1)*xm = 1; else *xm = -1;
      *ym = (y2-y1)/d_abs(x1-x2);
    }else{
     if(y2>y1)*ym = 1; else *ym = -1;
     *xm = (x2-x1)/d_abs(y1-y2);      
    }
  }else{
    *xm=0;*ym=0;
    if(x1==x2){
      if(y2>y1)*ym = 1; else *ym = -1;      
    }else{
      if(x2>x1)*xm = 1; else *xm = -1;
    }
  }
}

/* Palauttaa sat. luvun vlilt a-b */
signed int MiddleRand(signed int a, signed int b){
  if(b < a)return rand()%(a-b+1) + b;
  else return rand()%(b-a+1) + a;
}

/* Jrjest taulukon suuntaan a, jrj. alue */
signed int SortArrayArea(signed int * taulukko, signed int suunta, signed int araja, signed int yraja){
signed int x, xx, c;
  if(araja > yraja){x = yraja; yraja = araja; araja = x;}
  for(x = araja; x <= yraja; x++){
    for(xx = x; xx <= yraja; xx++){
      if((taulukko[xx] < taulukko[x] && suunta == UPPERWAY) || (taulukko[xx] > taulukko[x] && suunta == DOWNWAY)){
        c = taulukko[x]; taulukko[x] = taulukko[xx]; taulukko[xx] = c;
      }
    }
  }
  return taulukko[0];
}

/* Simuloi n-sivuisen nopan heittmist x kertaa, listn tulokseen y. */
signed int ThrowDice(signed int n, signed int x, signed int y){
signed int a, tul=0;
  if(n<=0||x==0)return 0;
  for(a=0;a<x;a++)
    tul += rand()%n;
  return tul+y;
}

/* 8-suuntaiselle liikkumiselle liike suunnan perusteella */
void xym_by_dir(signed int dir, signed int *xm, signed int *ym){  //palauttaa xm, ym sunnan mukaan.
  if(dir>0)dir %= 8; /* 0...7, -1 tuottaa 0,0:n */
  switch(dir){
    case 0: *xm = 0;  *ym = -1; break;
    case 1: *xm = 1;  *ym = -1; break;
    case 2: *xm = 1;  *ym = 0;  break;
    case 3: *xm = 1;  *ym = 1;  break;
    case 4: *xm = 0;  *ym = 1;  break;
    case 5: *xm = -1; *ym = 1;  break;
    case 6: *xm = -1; *ym = 0;  break;
    case 7: *xm = -1; *ym = -1; break;
    default: *xm = 0; *ym = 0;  break; //muuten (jos <0)
  }
}

/* 8-suuntaiselle liikkumiselle suunnanotto liikkeen perusteella. Kutsuttava xm [-1,1] ja ym [-1,1] */
void dir_by_xym(signed char *dir, signed int xm, signed int ym){  //antaa suunnan xm ja ym mukaan
  if(ABS(xm)>1 || ABS(ym)>1){*dir=-1;return;}
  switch(ym * 3 + xm){
    case -4: *dir = 7; break;
    case -3: *dir = 0; break;
    case -2: *dir = 1; break;
    case -1: *dir = 6; break;
    case 0: *dir = -1; break;
    case 1: *dir = 2; break;
    case 2: *dir = 5; break;
    case 3: *dir = 4; break;
    case 4: *dir = 3; break;
  };
}

/*
  Palauttaa enginen liput. Nin tieto voidaan vlitt mys muille moduleille.
*/
unsigned int ERKKI_FLAGS(){ return engine_dat; }

/*
  default recorder: Asennetaan Erkki_init():ss. Ei ilmoita mistn mitn ja antaa
  kaiken tapahtua.
*/
int DEFAULT_RECORDER(signed int cmd, signed int d1, signed int d2){
  return 0;
}

/* 
  Hakee jotain. Jos lytyy, palauttaa OK ja sijainnin, muuten tarpeen mukaan lukumrn tms.
  Jos ei lydy, palauttaa ERKKI_NOFOUND.
  Esineet: GET_ESINE_HANDLE palauttaa handlen x:ss, GET_ESINE_LOC palauttaa sijainnin.
  Hakemaan pystyy vain ptyyppej.
*/
int ERKKI_scan_for(KENTTA * kentta, signed int tunniste, signed int apu, int tyyppi, signed int * x, signed int * y){
unsigned int x1, y1, k, a;
  switch(tyyppi){
    case GET_OLIO_HANDLE: /* Haetaan jotain tietty oliota */ 
      for(x1 = 0; x1 < kentta->MaxCreature; x1++){
        if((kentta->Oliot[x1]->liput & Cr_D_On) && kentta->Oliot[x1]->oliotyyppi == tunniste){
          *x = kentta->Oliot[x1]->x; *y = kentta->Oliot[x1]->y;
          return x1;
        }
      }
      break;
    case GET_ESINE_HANDLE: /* Haetaan jotain tietty esinett (kahva). */ 
      for(k = 0; k < kentta->MaxItem; k++){
        if(kentta->Esineet[k].Esine.mika_esine >= 0){ /* Pll */
          if(kentta->Esineet[k].Esine.mika_esine == tunniste && 
             kentta->Esineet[k].Esine.linkki == apu){
            *x = k;
            return ERKKI_OK; /* Lytys */
          }
        }
      }
      break;
    case GET_ESINE_LOC: /* Haetaan jotain tietty esinett (sijainti). */ 
      for(y1 = 0; y1 < kentta->h; y1++)for(x1 = 0; x1 < kentta->w; x1++){
        k = x1+(y1 * kentta->w);
        if( kentta->Kentta[k].esine >= 0 ){
          a = kentta->Kentta[k].esine;
          while(1){
            if(a<0)break; /* Ketjun p */
            if( kentta->Esineet[a].Esine.mika_esine == tunniste && kentta->Esineet[a].Esine.linkki == apu ){
              *x = x1; *y = y1; //sijainti talteen
              return ERKKI_OK;
            }
            /* Jos ei jo ollut, niin seuraava ketjun jsen */
            a = kentta->Esineet[a].ylaketju;
          }
        }
      }
      break;
    case GET_OLIO_COUNT:
      k = 0;
      for(x1 = 0; x1 < kentta->MaxCreature; x1++){
        if((kentta->Oliot[x1]->liput & Cr_D_On) && kentta->Oliot[x1]->oliotyyppi >= 0){
          k++;
        }
      }
      return k;
      break;
    case GET_OLIO_COUNT_ALL: /* Laskee kaikki oliot (NPC:t + sankarit mukaan) */
      k = 0;
      for(x1 = 0; x1 < kentta->MaxCreature; x1++){
        if((kentta->Oliot[x1]->liput & Cr_D_On)){
          k++;
        }
      }
      return k;
      break;
  };

  return ERKKI_NOFOUND; /* Ei lydy */
}


signed int ERKKI_install_recorder(int (*f)(signed int, signed int, signed int)){
  if(f==NULL){
    ERKKI_Recorder = DEFAULT_RECORDER;
    return ERKKI_ERROR;
  }else ERKKI_Recorder = f;
  return ERKKI_OK;
}

int ERKKI_install_objects(OBJECTCLASS * objektit){
  ERKKI_Objektit = objektit;
  return ERKKI_OK;
}

int ERKKI_install_traps(TRAPCLASS * t){
  ERKKI_Ansat = t;
  return ERKKI_OK;
}

int ERKKI_install_act(ACTIVATECLASS * act){
  ERKKI_Aktivoi = act;
  return ERKKI_OK;
}

int ERKKI_init(unsigned int flg){
int a;
  if(!(engine_dat & ERKKI_INSTALLED)){
    printf(ERKKI_HEADER_INFO);
    printf("\n\rAlustetaan...");
    engine_dat |= (ERKKI_INSTALLED | flg);
    printf("OK\n\r");   
  }
  return ERKKI_OK;
}

int ERKKI_exit(){
int a;
  if(engine_dat & ERKKI_INSTALLED){
    printf("\n\rSammutetaan ERKKI...");
    engine_dat ^= ERKKI_INSTALLED;
    printf("OK\n\r");
    /* Tulostetaan viel infoa :) */
    printf(ERKKI_HEADER_INFO);
  }
  return ERKKI_OK;
}

/*
  Palauttaa osoittimen olioon nmr. kuka kentn oliotaulukossa. Tmn funktion
  avulla peli/ohjelmaa voi ohjelmoida ilman ett tytyy puuttua kentn taulukoihin.  
*/
CREATURESTACK * ERKKI_creature(KENTTA * kentta, signed int kuka){
CREATURESTACK * tmp = kentta->Oliot[0];
signed int a = 0;
  if(ERKKI_FLAGS() & ERKKI_DYNAMIC){
    while(tmp != NULL){
      if(a == kuka)return tmp; /* Oikea olio lytyi */
      tmp = tmp->next;
      a++;
    }
    return NULL;
  }else{
    if(kuka < 0 || kuka >= kentta->MaxCreature)return NULL;
    return kentta->Oliot[kuka];
  }
}

/*
  Palauttaa osoittimen kentn esineeseen nmr. link kentn esinetaulukossa (jos
  taulukkomuoto pll) tai tiettyyn jonon alkioon (dynaaminen muoto). Nin
  enginen kyttjn ei tarvitse puuttua lainkaan taulukoihin.
  Palauttaa NULL, jos esinett ei ole tai indeksi on vr (ulkopuolella
  rajojen).
  Kentn tietty indeksi osoittaa aina tiettyyn ITEMCLASS-olioon, jolla on
  tietty mr esineit. Tietyn esineen linkki on 
*/
ITEMCLASS * ERKKI_item(KENTTA * kentta, signed int link){
//ITEMCLASS * tmp = kentta->Esineet;
signed int a = 0;
  if(link < 0 || link >= kentta->MaxItem)return NULL;
  return &kentta->Esineet[link];
}

/*
  Varaa yhden CREATURESTACK-tyyppisen olion; olioon tarvittavat
  datamrt (MaxCrData, CrItems) ovat kentta-oliossa.
*/
CREATURESTACK * ERKKI_AllocateCreature(KENTTA * kentta){
CREATURESTACK * tmp;
int x;
  tmp = (CREATURESTACK*)malloc(sizeof(CREATURESTACK));
  if(tmp == NULL)return NULL;
  tmp->data = (unsigned int *)malloc(sizeof(unsigned int) * kentta->MaxCrData);
  if(tmp->data == NULL){
    free(tmp);
    return NULL;
  }
  for(x=0;x<kentta->MaxCrData;x++)tmp->data[x] = 0;
  tmp->varusteet = (unsigned int *)malloc(sizeof(unsigned int) * kentta->CrItems);
  if(tmp->varusteet == NULL){
    free(tmp->data);
    free(tmp);
    return NULL;
  }
  for(x=0;x<kentta->CrItems;x++)tmp->varusteet[x] = -1;
  /* Dynaaminen olionvaraus vaatii tmn, ja taulukoidussa systeemiss
     tll arvolla ei ole vli */
  tmp->next = NULL;
  return tmp;
}

/*
  Vapauttaa ERKKI_AllocateCreature():n varaaman muistin.
*/
void ERKKI_UnAllocateCreature(CREATURESTACK * cr){
  if(cr==NULL)return;
  if(cr->data)free(cr->data);
  if(cr->data)free(cr->varusteet);
  free(cr);
}

/********************************************
Kentnksittelyrutiinit
*********************************************/

/*
  Luo kenttolion (KENTTA) eli varaa muistia kaikille sen vaatimille rakenteille.
  ww: kentn leveys, hh: kentn korkeus, mc: olioiden max. mr, mi: esineiden max. mr
  mcd: olioiden datamuuttujien max. mr
  HUOM! Mikli engine on alustettu ERKKI_DYNAMIC-lipulla, olio- ja esinetaulukoihin
    ei voi viitata suoraan vaan on kytettv ERKKI_creature()- ja ERKKI_item()-funktioita.
  *elst: oliolinkkien varustusfiltteri. Jos != NULL, niin kenttoliot voivat kantaa esineit
  kuten inventorittomat oliot. cif on koko (kpl slotteja). Kaikki slotit alustetaan -1.
*/
KENTTA * ERKKI_KENTTA(unsigned int ww, unsigned int hh, unsigned int mc, unsigned int mi, unsigned int mcd,
unsigned int cif, signed int *elst){
KENTTA * temp;
signed int x;
  temp = (KENTTA*)malloc(sizeof(KENTTA)); /* Varataan tilaa... */
  if(ww <= 0 || hh <= 0)return NULL;
  if(temp == NULL)return NULL;
  temp->Kentta = (KENTTABLOCK*)malloc(sizeof(KENTTABLOCK)*ww*hh); /* Varataan muistia mokomalle */
  if(temp->Kentta == NULL){
    free(temp);
    return NULL;
  }

  temp->w = ww; temp->h = hh;
  temp->MaxItem = mi; temp->MaxCreature = mc; temp->MaxCrData = mcd;
  temp->CrItems = cif; temp->CrFilter = elst;

  if(mc > 0){ /* Pit varata olioille tilaa */
    if(ERKKI_FLAGS() & ERKKI_DYNAMIC){ /* Dynaaminen; olioilla ei max. mr. */
      /* Osoitin ensimmiseen olioon = NULL (ei olioita) */
      temp->Oliot[0] = NULL;
    }else{ /* Olioille varataan tilaa taulukkoon; kentll max. mc oliota */
      /* Varataan pointteritaulukko */
      temp->Oliot = (CREATURESTACK**)malloc(sizeof(CREATURESTACK*)*mc);
      if(temp->Oliot == NULL){
        free(temp->Kentta);
        free(temp);
        return NULL;
      }
      for(x=0;x<mc;x++){
        if((temp->Oliot[x] = ERKKI_AllocateCreature(temp))==NULL){x=-1;break;}
      }
      if(x<0){
        free(temp->Oliot);
        free(temp->Kentta);
        free(temp);
        return NULL;
      }
    }
  }else temp->Oliot = NULL;

  if(mi > 0){
    temp->Esineet = (ITEMCLASS*)malloc(sizeof(ITEMCLASS)*mi); /* Varataan muistia mokomalle */
    if(temp->Esineet == NULL){
      free(temp->Oliot);
      free(temp->Kentta);
      free(temp);
      return NULL;
    }
  }else temp->Esineet = NULL;

  ERKKI_init_map(temp, 0); /* alustetaan */
  return temp;
}

/* Vapauttaa kenttn varatun muistin */
void ERKKI_KENTTA_free(KENTTA * kentta){
unsigned int x;
  free(kentta->Kentta);
  if(kentta->Oliot!=NULL){
    if(ERKKI_FLAGS() & ERKKI_DYNAMIC){
      ERKKI_init_creatures(kentta);
    }else{
      for(x=0;x<kentta->MaxCrData;x++)ERKKI_UnAllocateCreature(kentta->Oliot[x]);
    }
    free(kentta->Oliot);
  }
  if(kentta->Esineet!=NULL){
    if(ERKKI_FLAGS() & ERKKI_DYNAMIC){
      ERKKI_init_items(kentta);
    }
    free(kentta->Esineet);
  }
  free(kentta);
}

/*
  Tm nollaa kaikki oliot kentlt. Vhemmn erroreita pelattaessa.
*/
int ERKKI_init_creatures(KENTTA * kentta){
int x, z;
CREATURESTACK * tmp, * tmp2;
  if(ERKKI_FLAGS() & ERKKI_DYNAMIC){ /* Initioidaan eli poistetaan */
    tmp = kentta->Oliot[0];
    while(tmp != NULL){tmp2 = tmp->next; ERKKI_UnAllocateCreature(tmp); tmp = tmp2->next;}
  }else{
    for(x=0;x<kentta->MaxCreature;x++){
      tmp = ERKKI_creature(kentta, x);
      if(tmp==NULL)break;
      tmp->elo = -1; tmp->mana = -1; tmp->oliotyyppi = -1;
      tmp->x = -1;  tmp->y = -1;
      tmp->kx = -1; tmp->ky = -1;
      tmp->liput = 0; /* ... paitsi tm ja datat */
      for(z=0;z<kentta->MaxCrData;z++)tmp->data[z] = 0;
      for(z=0;z<kentta->CrItems;z++)tmp->varusteet[z] = -1;
    }
  }
  return ERKKI_OK;
}

int ERKKI_init_items(KENTTA * kentta){
ITEMCLASS *tmp;
int x;
  for(x=0;x<kentta->MaxItem;x++){
    tmp = ERKKI_item(kentta, x);
    if(tmp){
      memset(tmp, 0, sizeof(ITEMCLASS)); /*nolla nolla...*/
      tmp->Esine.mika_esine = -1; /* ... paitsi tm */
    }
  }
}

/*
  Alustaa koko kentn tysin tyhjksi: ei olioita, esineit, seini eik mitn :)
  Kentn maasto alustetaan annettuun arvoon.
*/
int ERKKI_init_map(KENTTA * kentta, int maa){
int x,y,k;
  for(y=0;y<kentta->h;y++)
    for(x=0;x<kentta->w;x++){
      k = x+y*kentta->w; /* Optimointia */
      kentta->Kentta[k].objekti = -1;
      kentta->Kentta[k].ansa = -1;
      kentta->Kentta[k].maalaatu = maa;
      kentta->Kentta[k].olio = -1;
      kentta->Kentta[k].esine = -1;
      kentta->Kentta[k].data = 0;
    }
  ERKKI_init_items(kentta);
  ERKKI_init_creatures(kentta);
  return ERKKI_OK;
}

/*
  Tallentaa kentn valittuun fileen (pakaten sen). Tallentaa vain kentn
  sekundrisen datan, ei koko dataa. Koko datan tallentaa
  ERKKI_KENTTA_save_full().
*/
int ERKKI_KENTTA_save(KENTTA *kentta, FILE * tiedosto){
unsigned long c = (kentta->h * kentta->w), d;
unsigned char t;
signed int r;
CREATURESTACK * olio;
  if(tiedosto == NULL)return ERKKI_ERROR;
  if(olio == NULL)return ERKKI_ERROR;
  for(d = 0; d < c; d++){
    t = 0;
    if(kentta->Kentta[d].objekti >= 0)t |= ERKKI_F_OBJEKTI;
    if(kentta->Kentta[d].esine >= 0)t |= ERKKI_F_ESINE;
    if(kentta->Kentta[d].olio >= 0)t |= ERKKI_F_OLIO;
    fputc(t, tiedosto);
    fwrite(&kentta->Kentta[d].data, sizeof(kentta->Kentta[d].data), 1, tiedosto);
    fwrite(&kentta->Kentta[d].maalaatu, sizeof(kentta->Kentta[d].maalaatu), 1, tiedosto);
    if(t & ERKKI_F_OBJEKTI)fwrite(&kentta->Kentta[d].objekti, sizeof(kentta->Kentta[d].objekti), 1, tiedosto);
    if(t & ERKKI_F_ESINE){
      fwrite(&kentta->Kentta[d].esine, sizeof(kentta->Kentta[d].esine), 1, tiedosto);
      //Tallennetaan esinelinkki
      fwrite(&kentta->Esineet[kentta->Kentta[d].esine], sizeof(kentta->Esineet[kentta->Kentta[d].esine]), 1, tiedosto);
      //Kydn kasa lpi tallentaen
      r = kentta->Esineet[kentta->Kentta[d].esine].ylaketju;
      while(r >= 0){
        fwrite(&kentta->Esineet[r], sizeof(kentta->Esineet[r]), 1, tiedosto);
        r = kentta->Esineet[r].ylaketju;
      }
    }
    if(t & ERKKI_F_OLIO){ /* Kohdassa on olio! */
      olio = ERKKI_creature(kentta, kentta->Kentta[d].olio);
      ERKKI_write_single_creature(kentta, olio, tiedosto);
      //&kentta->Oliot[kentta->Kentta[d].olio]
    }
  }/*for d*/ 
  return ERKKI_OK;
}

/*
  Hakee pakatun kentn streamista. HUOM! kentn on oltava ladattavan tiedoston kokoinen;
  koko kentn lataukseen suositellaan funktiota:
  ERKKI_KENTTA_load_full()
*/
int ERKKI_KENTTA_load(KENTTA *kentta, FILE * tiedosto){
unsigned long c = (kentta->h * kentta->w), d;
unsigned char t;
signed int r, x, y;
CREATURESTACK * olio = ERKKI_AllocateCreature(kentta), *tmp;
  if(tiedosto == NULL)return ERKKI_ERROR;
  if(olio == NULL)return ERKKI_ERROR;
  ERKKI_init_creatures(kentta);
  for(d = 0; d < c; d++){
    t = 0;
    t = fgetc(tiedosto);
    if( t & ERKKI_F_ERROR ){fclose(tiedosto);return ERKKI_ERROR;} /* Lukuvirhe */
    fread(&kentta->Kentta[d].data, sizeof(kentta->Kentta[d].data), 1, tiedosto);
    fread(&kentta->Kentta[d].maalaatu, sizeof(kentta->Kentta[d].maalaatu), 1, tiedosto);
    if(t & ERKKI_F_OBJEKTI)fread(&kentta->Kentta[d].objekti, sizeof(kentta->Kentta[d].objekti), 1, tiedosto);
      else kentta->Kentta[d].objekti = -1;
    if(t & ERKKI_F_ESINE){
      fread(&kentta->Kentta[d].esine, sizeof(kentta->Kentta[d].esine), 1, tiedosto); //saadaan linkki esineslottiin
      fread(&kentta->Esineet[kentta->Kentta[d].esine], sizeof(kentta->Esineet[kentta->Kentta[d].esine]), 1, tiedosto);
      r = kentta->Esineet[kentta->Kentta[d].esine].ylaketju;
      while(r >= 0 ){ //ketju on tallennettu!
        fread(&kentta->Esineet[r], sizeof(kentta->Esineet[r]), 1, tiedosto);
        r = kentta->Esineet[r].ylaketju; //jatkuuko kasa viel?
      }
    }else kentta->Kentta[d].esine = -1;
    if(t & ERKKI_F_OLIO){
      /* Kohdassa d on olio. Lasketaan X,Y */
      x = d % kentta->w; y = (int)(d / kentta->w);
      kentta->Kentta[d].olio = -1;
      ERKKI_read_single_creature(kentta, olio, tiedosto);
      ERKKI_PutCreatureToMap(kentta, olio, x, y);
    }else kentta->Kentta[d].olio = -1;
  }/*for d*/
  ERKKI_UnAllocateCreature(olio);
  return ERKKI_OK;
}

int ERKKI_onkoeste(KENTTA * kentta, signed int x, signed int y, unsigned int tyyli){
signed int k=x+y*kentta->w; /* Optimointia */
  if(x<0||y<0||x>=kentta->w||y>=kentta->h)return Este_Rajanyli;
  if(kentta->Kentta[k].olio >= 0 && (tyyli & este_olio)==0)return Este_Olio;
  if(kentta->Kentta[k].objekti > -1){ /* Mahdollinen este */
    //lpimentv / aukinainen ei ole este
    if(ERKKI_Objektit[kentta->Kentta[k].objekti].data & ObjAuki)
      return ERKKI_OK; 
    if((ERKKI_Objektit[kentta->Kentta[k].objekti].data & ObjLapi) && !(tyyli & este_tyyli_nako))
      return ERKKI_OK; 
    switch(ERKKI_Objektit[kentta->Kentta[k].objekti].tyyppi){
      case ObjektiLuokkaMuuri: 
        /* Objektista voi kulkea lpi aaveena */
        if(tyyli & este_tyyli_ghost)return ERKKI_OK;
        return Este_Este; 
        break;
      case ObjektiLuokkaOvi: 
        /* Objektista voi kulkea lpi aaveena */
        if(tyyli & este_tyyli_ghost)return ERKKI_OK;
        return Este_Ovi; 
        break;
      case ObjektiLuokkaNeste: 
        /* Nesteet voi ylitt lentmll */
        if(tyyli & este_tyyli_fly)return ERKKI_OK;
        return Este_Neste; //muuten
        break;
      case ObjektiLuokkaKasvi:
        /* Objektista voi kulkea lpi aaveena, tai lenten */
        if(tyyli & (este_tyyli_ghost | este_tyyli_fly) && !(tyyli & este_tyyli_nako))return ERKKI_OK;
        return Este_Kasvi;
        break;
      case ObjektiLuokkaPortaat:
        /* Objektista voi kulkea lpi aaveena */
        if(tyyli & este_tyyli_ghost)return ERKKI_OK;
        return Este_Portaat;
        break;
      default : break;
    };
  }
  return ERKKI_OK; //ei estett
}

signed int inline ERKKI_getobject(KENTTA *kentta, int x, int y){
  return kentta->Kentta[x+(y*kentta->w)].objekti;
}

signed int inline ERKKI_getmaasto(KENTTA *kentta, int x, int y){
  return kentta->Kentta[x+(y*kentta->w)].maalaatu;
}

/*
  Piirt viivan objekteista kentlle. Toimii kuten QB:n LINE-ksky.
*/
void ERKKI_obj_line(KENTTA * kentta, signed int x1, signed int y1, signed int x2, signed int y2, 
signed int objekti, char tyyli){
double x, y, xm, ym;
int eta;
  /* Rajojen tarkistus */
  if(x1<0)x1=0;if(y1<0)y1=0;
  if(x2>kentta->w-1)x2=kentta->w-1;if(y2>kentta->h-1)y2=kentta->h-1;
  if(tyyli==OBJLINE_LINE){
    count_angle_move(x1, y1, x2, y2, &xm, &ym);
    eta = MAX(ABS(x1-x2),ABS(y1-y2));
    x = x1; y = y1;
    for(;eta>=0;eta--){
      kentta->Kentta[(int)x+((int)y)*kentta->w].objekti = objekti;
      x += xm; y += ym;
    }
  }else{
    /* Vaihdetaan jos vrinpin */
    if(x2<x1){eta=x1;x1=x2;x2=eta;}
    if(y2<y1){eta=y1;y1=y2;y2=eta;}
    /* reunat */
    if(tyyli==OBJLINE_RECT){
      for(y=y1;y<=y2;y++){
        kentta->Kentta[x1+((int)y)*kentta->w].objekti = objekti;
        kentta->Kentta[x2+((int)y)*kentta->w].objekti = objekti;
      }
      for(x=x1+1;x<=x2-1;x++){
        kentta->Kentta[(int)x+y1*kentta->w].objekti = objekti;
        kentta->Kentta[(int)x+y2*kentta->w].objekti = objekti;
      }
    }else if(tyyli == OBJLINE_FILL){ /* tytetn viel sisuskin */
      for(y=y1;y<=y2;y++){
      for(x=x1;x<=x2;x++){
        kentta->Kentta[(int)x+((int)y)*kentta->w].objekti = objekti;
      }}
    }
  } /* else */
}

void ERKKI_obj_pset(KENTTA * kentta, signed int x1, signed int y1, signed int obj){
  kentta->Kentta[(x1)+(y1)*kentta->w].objekti = obj;
}

/* Kuin yll, mutta piirt maalaatua objektin sijaan :) */
void ERKKI_ground_line(KENTTA * kentta, signed int x1, signed int y1, signed int x2, signed int y2, 
unsigned int maa, char tyyli){
double x, y, xm, ym;
int eta;
  /* Vaihdetaan jos vrinpin */
  if(x2<x1){x=x1;x1=x2;x2=(int)x;}
  if(y2<y1){y=y1;y1=y2;y2=(int)y;}
  /* Rajojen tarkistus */
  if(x1<0)x1=0;if(y1<0)y1=0;
  if(x2>kentta->w-1)x2=kentta->w-1;if(y2>kentta->h-1)y2=kentta->h-1;
  if(tyyli==0){
    count_angle_move(x1, y1, x2, y2, &xm, &ym);
    eta = MAX(ABS(x1-x2),ABS(y1-y2));
    x = x1; y = y1;
    for(;eta>=0;eta--){
      kentta->Kentta[(int)x+((int)y)*kentta->w].maalaatu = maa;
      x += xm; y += ym;
    }
  }else{
    /* reunat */
    if(tyyli==1){
      for(y=y1;y<=y2;y++){
        kentta->Kentta[x1+((int)y)*kentta->w].maalaatu = maa;
        kentta->Kentta[x2+((int)y)*kentta->w].maalaatu = maa;
      }
      for(x=x1+1;x<=x2-1;x++){
        kentta->Kentta[(int)x+y1*kentta->w].maalaatu = maa;
        kentta->Kentta[(int)x+y2*kentta->w].maalaatu = maa;
      }
    }else if(tyyli == 2){ /* tytetn viel sisuskin */
      for(y=y1;y<=y2;y++){
      for(x=x1;x<=x2;x++){
        kentta->Kentta[(int)x+((int)y)*kentta->w].maalaatu = maa;
      }}
    }
  } /* else */
}

void ERKKI_ground_pset(KENTTA * kentta, signed int x1, signed int y1, unsigned char maa){
  kentta->Kentta[(x1)+(y1)*kentta->w].maalaatu = maa;
}


/* 
  Luo luolan annetuilla objekteilla... hienost 
  (olioiden + muun (ovet) lisys) on mahdollista luonnin jlkeen
  vaikka ERKKI_putdoors...
*/
int ERKKI_luo_luola(KENTTA * kentta, signed int Muuri, unsigned int Lattia, unsigned int Tunneli){
  int rx[MAXROOM], ry[MAXROOM], rs[MAXROOM][2];
  int x, y, q, r, laajuus=0, w;
  /* Alustetaan objektilla ja annetulla lattialla */
  ERKKI_obj_line(kentta, 0 , 0, kentta->w - 1, kentta->h - 1, Muuri, 2);
  ERKKI_ground_line(kentta, 0 , 0, kentta->w - 1, kentta->h - 1, Tunneli, 2);
  //haetaan huoneiden sijainnit
  //huoneen 1 sijainti ja koko (esiasetus)
  x = 1; y = 1; q = 0;
  for(r=0;r<MAXROOM;r++){
    x += 10;
    if(x >= kentta->w){y = y + 10; x = 1;}
    if(y >= kentta->h)break;
    if(rand()%3){  /* Huone tuli... */
      rx[q] = x + 1 + rand()%3;
      ry[q] = y + 1 + rand()%3;
      rs[q][0] = 3 + (int)(rand()%(ABS(x + 10 - rx[q] - 1)+1));
      rs[q][1] = 3 + (int)(rand()%(ABS(y + 10 - ry[q] - 1)+1));
      laajuus++;
      q++;
    }
  } /* r */
  //sekoitetaan huoneiden jrjestys!
  for(r=0;r<laajuus;r++){
    if(rand()%3){
      y = rand()%(r+1);  //mink kanssa
      x = rx[r]; rx[r] = rx[y]; rx[y] = x;
      x = ry[r]; ry[r] = ry[y]; ry[y] = x;
    }
  } //r
  //laitetaan huoneet
  for(r=0;r<laajuus;r++){
    //piirretn huone
    for(x=rx[r];x<rx[r]+rs[r][0];x++){
    for(y=ry[r];y<ry[r]+rs[r][1];y++){
      if(x>0 && y>0 && x<kentta->w-1 && y<kentta->h-1){
        kentta->Kentta[x+y*kentta->w].maalaatu = Lattia;
        kentta->Kentta[x+y*kentta->w].objekti = -1; //ei objektia
      }
    }}
    //siirretn hieman huoneen koord. -> tunneli etenee kohti huoneen keskustaa
    rx[r] = rx[r] + rand()%(rs[r][0]-1) + 1;
    if(rx[r] >= kentta->w - 2)rx[r]=kentta->w-3;
    ry[r] = ry[r] + rand()%(rs[r][1]-1) + 1;
    if(ry[r] >= kentta->h - 2)ry[r]=kentta->h-3;
  } /* r */

  /* piirretn tunnelit */

  w = rand()%2;
  q = 0; // onko piirrosestett?
  for(r=0;r<laajuus-1;r++){
    x = rx[r]; y = ry[r];
    while(1){      
      if(w==0){
        if(x<rx[r+1]){
          x ++;
        }else if(x>rx[r+1]){
          x --;
        }
      }else{
        if(y<ry[r+1]){
          y ++;
        }else if(y>ry[r+1]){
          y --;
        }
      }
      if(rand()%5 == 0 || x == rx[r+1] || y == ry[r+1]){
       w=(w==0); 
      }
   
      if(x==rx[r+1] && y==ry[r+1])break;

      if(kentta->Kentta[x+y*kentta->w].objekti == Muuri && !q){
        kentta->Kentta[x+y*kentta->w].maalaatu = Tunneli;
        kentta->Kentta[x+y*kentta->w].objekti = -1;
      }
    } /* while */
  } /* r */  
  return ERKKI_OK;
}

/*
  maastosotku: tekee sattumanvaraisen patternin annetuista maalaaduista.  
*/
int ERKKI_maastosotku(KENTTA * kentta, int pmaasto, int maasto1, int maasto2){
int x,y;
  ERKKI_ground_line(kentta, 0 , 0, kentta->w - 1, kentta->h - 1, pmaasto, 2); /* Perusmaasto */
  for(x=0;x<kentta->w;x++)for(y=0;y<kentta->h;y++){
    if(rand()%3==0){
      if(rand()%2==0)kentta->Kentta[x+y*kentta->w].maalaatu = maasto1; 
      else kentta->Kentta[x+y*kentta->w].maalaatu = maasto2;
    }
  }
  return ERKKI_OK;
}

/*
  Kasaa objekteja sattumanvaraisesti kentlle annetulla tiheydell (0-100)%
*/
int ERKKI_objektisotku(KENTTA * kentta, int objekti, int tiheys){
int x,y;
  for(x=0;x<kentta->w;x++)for(y=0;y<kentta->h;y++){
    if(rand()%100 < tiheys){
      kentta->Kentta[x+y*kentta->w].objekti = objekti;
    }
  }
  return ERKKI_OK;
}

/* Vaihtaa objektin tietyll todennkisyydell toiseksi */
int ERKKI_objectswap(KENTTA * kentta, signed int mika, signed int miksi, unsigned int tod){
signed int x, y, k;
  for(y=0;y<kentta->h;y++)for(x=0;x<kentta->w;x++)
    if(rand()%100 < tod){
      k = x + y * kentta->w;
      if(kentta->Kentta[k].objekti == mika)kentta->Kentta[k].objekti = miksi;
    }
  return ERKKI_OK;
}

/* 
  Algoritmi ovien laittamiseksi.
  Ovi tulee vain huoneen ja kytvn rajamaalle. 
  Laittaa oven jokaiseen mahd. paikkaan.
*/
signed int ERKKI_putdoors(KENTTA * kentta, signed int n_ovi){
int x,y,xm,ym;
  for(y=1;y<kentta->h-1;y++)for(x=1;x<kentta->w-1;x++){
    if(kentta->Kentta[x+(y*kentta->w)].objekti < 0){ /* ei objektia */
      xm=-1;ym=-1;
      /* Ymprystilet */
      if(kentta->Kentta[(x-1)+y*kentta->w].objekti == kentta->Kentta[x+1+y*kentta->w].objekti)
        xm = kentta->Kentta[x+1+y*kentta->w].objekti;
      if(kentta->Kentta[x+(y-1)*kentta->w].objekti == kentta->Kentta[x+(y+1)*kentta->w].objekti)
        ym = kentta->Kentta[x+(y+1)*kentta->w].objekti;
      if( (xm>=0 && ym<0) ){
        /* Ovi _vain_ muurin viereen */
        if(ERKKI_Objektit[xm].tyyppi == ObjektiLuokkaMuuri && 
          kentta->Kentta[x+(y-1)*kentta->w].maalaatu != kentta->Kentta[x+(y+1)*kentta->w].maalaatu){ 
          kentta->Kentta[x+(y)*kentta->w].objekti = n_ovi;
        }
      }else if( (xm<0 && ym>=0) ){
        if(ERKKI_Objektit[ym].tyyppi == ObjektiLuokkaMuuri && 
          kentta->Kentta[x-1+(y)*kentta->w].maalaatu != kentta->Kentta[x+1+(y)*kentta->w].maalaatu){
          kentta->Kentta[x+(y)*kentta->w].objekti = n_ovi;
        }        
      }
    } /* if objekti < 0 */
  }/* for x */
}

/* 
  Keskitt kentn/kartan. Parametreina katselupiste ja koko (max, ruutu), kartan sijainti sijoitetaan xx ja yy
*/
void ERKKI_center(signed int x, signed int y, unsigned int wm, unsigned int hm, unsigned int w, 
unsigned int h, unsigned int * xx, unsigned int * yy){
signed int w1 = (int)(w/2), h1 = (int)(h/2), x2, y2;
  x2 = x - w1; y2 = y - h1;
  if(x2<0)x2=0; if(y2<0)y2=0;
  if(x2>wm-w)x2 = wm-w;
  if(y2>hm-h)y2 = hm-h;
  *xx = x2; *yy=y2;
}

/*
  Ksittelee karttaa kohdassa x,y. Laukaisee objekteihin asetetut triggerit.
  kuka on olion handle (saadaan mm. CreatureHandle-funktiolla)
*/
int ERKKI_HandleMap(KENTTA * kentta, signed int kuka, signed int x, signed int y, unsigned int tyyli){
int k, a, hx, hy;
ITEMSCLASS esine;
  if( NOTINMAP(kentta, x, y) )return ERKKI_ERROR;
  if( kuka < 0 || kuka >= kentta->MaxCreature )return ERKKI_ERROR;
  CreaturePos(kentta, kuka, &hx, &hy);
  k = (x) + (y*kentta->w); /* Opt Opt... */
  if(kentta->Kentta[k].objekti < 0)return ERKKI_OK;
  else{
    switch(tyyli){
      case StTouch:
        switch(a = GetTouch(ERKKI_Objektit[kentta->Kentta[k].objekti].data)){
          case TouchMuuta:
            kentta->Kentta[k].objekti = ERKKI_Objektit[kentta->Kentta[k].objekti].linkki2;
            break;
          case TouchAktivoi:
            if(kentta->Kentta[k].ansa<0)return ERKKI_ERROR;
            ActivateEvent(kentta, &ERKKI_Aktivoi[kentta->Kentta[k].ansa], hx, hy);
            break;
          case TouchEsine:
            memset(&esine, 0, sizeof(ITEMSCLASS));
            esine.mika_esine = ERKKI_Objektit[kentta->Kentta[k].objekti].linkki2;
            esine.linkki = ERKKI_Objektit[kentta->Kentta[k].objekti].data2;
            //CopyItemToMap(kentta, &esine, x, y);
            break;
          case TouchMurskaa:
            kentta->Kentta[k].objekti = -1;
            break;
          case TouchSattuu:
            DamageCreature(kentta, kuka, ERKKI_Objektit[kentta->Kentta[k].objekti].damage);
            break;
          default: break;          
        };
        return a;
        break;
      case StKick:
        switch(a = GetKick(ERKKI_Objektit[kentta->Kentta[k].objekti].data)){
          case KickMuuta:
            kentta->Kentta[k].objekti = ERKKI_Objektit[kentta->Kentta[k].objekti].linkki;
            break;
          case KickSattuu:
            DamageCreature(kentta, kuka, ERKKI_Objektit[kentta->Kentta[k].objekti].damage);
            break;
          case KickAktivoi:
            if(kentta->Kentta[k].ansa<0)return ERKKI_ERROR;
            ActivateEvent(kentta, &ERKKI_Aktivoi[kentta->Kentta[k].ansa], hx, hy);            
            break;
          case KickEsine: case KickEsine_D:
            memset(&esine, 0, sizeof(ITEMSCLASS));
            esine.mika_esine = ERKKI_Objektit[kentta->Kentta[k].objekti].linkki2;
            esine.linkki = ERKKI_Objektit[kentta->Kentta[k].objekti].data2;
            //CopyItemToMap(kentta, &esine, x, y);
            if(a==KickEsine_D)kentta->Kentta[k].objekti = -1;
            break;
          case KickMurskaa:
            kentta->Kentta[k].objekti = -1;
            break;
          default: break;          
        };
        return a;
        break;
    };
  }
  return ERKKI_OK;
}


/******************************
Tehtv-, ansa- ja aktivointirutiinit
******************************/

/* Tarkistaa tehtvn tilan */
signed int TriggerState(TRIGGER *homma, KENTTA *kentta){
int r, a, b;
  switch(homma->aihe){
    case CLEAR_AREA:
      b = 0;
      for(a=0;a<kentta->MaxCreature;a++){
        if(kentta->Oliot[a]->liput & Cr_D_On){
          if(kentta->Oliot[a]->oliotyyppi != homma->kuka && (homma->data1 == WhatCreaturePalette(
             kentta->Oliot[a]->oliotyyppi) || homma->data1 < 0))b++;
        }
      }
      if( b <= 0 )return TRIGGER_DONE; //ei lydy kohdetta
      break;
    case KILL_CREATURE: 
      /* Oliota ei lydy -> tehtv siis suoritettu */
      if( CreatureHandle(kentta, homma->kuka) == ERKKI_NOFOUND )return TRIGGER_DONE;
      break;
    case FIND_LOCATION:
      if( (r = CreatureHandle(kentta, homma->kuka)) == ERKKI_NOFOUND)return TRIGGER_FAILED; /* Hahmo ei en hengiss */
      /* Sijainti saavutettu? */
      if( (kentta->Oliot[r]->x == homma->data1 || homma->data1 < 0) && 
          (kentta->Oliot[r]->y == homma->data2 || homma->data2 < 0) ) return TRIGGER_DONE;
      break;
    case STAND_ON_G:
      if( (r = CreatureHandle(kentta, homma->kuka)) == ERKKI_NOFOUND)return TRIGGER_FAILED; /* Hahmo ei en hengiss */
      if( kentta->Kentta[kentta->Oliot[r]->x + (kentta->Oliot[r]->y * kentta->w)].objekti == homma->data1)
        return TRIGGER_DONE;
      break;
    default: break;
  };
  return TRIGGER_NO;
}

signed int ActivateEvent(KENTTA * kentta, ACTIVATECLASS *act, signed int x, signed int y){
signed int w,h,x1,y1;
long c;
  /* Luomisfunktioissa sijainti on data1,2 */
  if(NOTINMAP(kentta, act->data1, act->data2)){
    x1 = x; y1 = y;
  }else{
    x1 = act->data1; y1 = act->data2;
  }
  switch(act->aihe){
    case ACT_SHOW_MAP:
      c = kentta->w * kentta->h - 1;
      for(;c>=0;c--)kentta->Kentta[c].data |= (ERKKI_LOS_SEEN|ERKKI_LOS_LIGHT);
      break;
    case ACT_KILL_CREATURE:
      h = CreatureHandle(kentta, act->data1);
      if(h<0)return ERKKI_ERROR;
      DeleteCreature(kentta, h);
      break;
    case ACT_CREATE_OBJECT:
      if(NOTINMAP(kentta, x1, y1))return ERKKI_ERROR;
      kentta->Kentta[x + (y * kentta->w)].objekti = act->data3;
      break;
    case ACT_HIDE_MAP:
      c = kentta->w * kentta->h - 1;
      for(;c>=0;c--)kentta->Kentta[c].data ^= (kentta->Kentta[c].data&(ERKKI_LOS_SEEN|ERKKI_LOS_LIGHT));
      break;
    case ACT_CREATE_TRAP:
      if(NOTINMAP(kentta, x1, y1))return ERKKI_ERROR;
      kentta->Kentta[x + (y * kentta->w)].ansa = act->data3;      
      break;
    case ACT_CREATE_CR:
      if(NOTINMAP(kentta, x1, y1))return ERKKI_ERROR;
      PutCreatureToMap(kentta, act->data3, x1, y1);
      break;
    /* Tm toimii hieman eri tavalla... Surmaa olion ensisijaisesti 
       annetusta sijannista, muuten funktiokutsun sijainnista.*/
    case ACT_KILL_CREATURE_POS:
      if(NOTINMAP(kentta, act->data1, act->data2)){
        if(NOTINMAP(kentta, x, y))return ERKKI_ERROR;
        else{
          h = kentta->Kentta[x+(y*kentta->w)].olio; /* Handle talteen */
        }
      }else{
        h = kentta->Kentta[act->data1+(act->data2*kentta->w)].olio;
      }
      if(h>=0)DeleteCreature(kentta, h);
      else return ERKKI_ERROR;
      break;
  };
  return ERKKI_OK; 
}

/* Ansan laukaisu! Vaikutus kohdistuu sijaintiin x,y ja olioon kuka. */
signed int LaunchTrap(KENTTA * kentta, TRAPCLASS * tr, signed int x, signed int y, signed int kuka){
unsigned int f;
  switch(tr->mika_ansa){
    case TRAP_DAMAGE:
      DamageCreature(kentta, kuka, MiddleRand(tr->data1, tr->data2));
      break;
    case TRAP_HOLD:
      f = CreatureData(kentta, kuka, GET_C_FLAG, 0, SUB_CREATURE);
      f |= Cr_D_Stuck;
      ModifyCreature(kentta, kuka, GET_C_FLAG, 0, f, SUB_CREATURE);
      break;
    case TRAP_KILL:
      DeleteCreature(kentta, kuka);
      break;
  };
  return ERKKI_OK;
}

#ifdef __cplusplus
}
#endif
