/*
  ERKKI 0.8.5
  TARMO KORPELA
  takorpel@cc.joensuu.fi
  H-tiedosto
*/

#ifndef _ERKKI_H_
#define _ERKKI_H_

//#define TXT_ENGLISH

#include <stdio.h>  /* Tiedostot */
#include <string.h> /* Teksti */
#include <stdlib.h> /* yleist */
#include <math.h>   /* atan */

#ifndef NULL
  #define NULL 0X0
#endif

/* EI-data, kytetn enginess kun ei haluta listietoa */
#ifndef NON_INFO
  #define NON_INFO 0X0
#endif

#define ERKKI_HEADER_INFO "ERKKI v. 0.8.5, Pivitetty 15.01.2005\r\nTarmo Korpela, takorpel@cc.joensuu.fi"

#ifndef MaxOlioDataNum
# define MaxOlioDataNum 4
#endif

#ifndef MaxItemDataNum
# define MaxItemDataNum 4
#endif

/* Montako oliopalettia voidaan max. tunkea engineen? */
#define MAX_CR_PALETTES 8

#define ERKKI_TRAP     3  /* MoveCreaturen palautus, jos astuttiin ansaan */
#define ERKKI_DELITEM  2  /* Yleinen palautus esinefunktioilta */
#define ERKKI_KILLED   1  /* Olio/asia/esine tapettu */
#define ERKKI_OK       0  /* Normaali tapahtumaton tapahtuma eli kaikki OK. */
#define ERKKI_ERROR   -1  /* On tapahtunut virhe (fataali tai ei...) */
#define ERKKI_NOROOM  -2  /* Ei tilaa */
#define ERKKI_NOITEM  -3  /* Ei esinett */
#define ERKKI_NOFOUND -4  /* Ei lydy haettua asiaa */

/* Tallennusrutiiniin pari vakiota */
#define ERKKI_F_OBJEKTI 128  /* Palassa on objekti */
#define ERKKI_F_ESINE   64   /* Palassa on esine */
#define ERKKI_F_OLIO    32   /* Palassa on olio */
#define ERKKI_F_ERROR   31   /* Virhemaski - jos nit bittej pll, on tapahtunut virhe */

#define ERKKI_INSTALLED 0X1   /* Onko ERKKI asetettu */
#define ERKKI_DYNAMIC   0X2   /* Kytetnk muistia dynaamisesti? Tllin ei rajoja ole... */

/*
  Yleiset definet; muuta vastaamaan haluamaasi.
*/

#define Max_Motion_Step 1 //Montako askelta olion muistissa on?


#define MAXROOM 100 /* Maks. mr huoneita satunnaisella kentll */

/* Palautusarvoja */

/* onko_este */
#define Este_Rajanyli 1 /* Liike veisi yli kentn rajojen */
#define Este_Ovi      2 /* Ovityypin obj esteen */
#define Este_Neste    3 /* Nestetyypin obj esteen */
#define Este_Olio     4 /* Olio esteen */
#define Este_Kasvi    5 /* Kasvityypin obj esteen */
#define Este_Portaat  6 /* Porrastyypin obj esteen */
#define Este_Kiinni   7 /* Kiinni jossakin - ei liiku lainkaan */
#define Este_Este     8 /* The Este - ei pse mitenkn liikkeelle. */

/* onko_este-funktioon lisparametrit */
#define este_tyyli_fly   1 /* Lent - nestetyyppi ei este */
#define este_tyyli_ghost 2 /* Aave - mikn objekti ei ole este (paitsi nesteet) */
#define este_tyyli_pre   4 /* Esink - jos esine avattavissa, ei este. Reittialg. voisi kytt tt */
#define este_olio        8 /* Olio ei ole este (esim. nkeminen) */
#define este_tyyli_nako 16 /* Nkeminen; ObjLapi on este */

/* Objektivakiot */
#define ObjektiLuokkaMuuri 1
#define ObjektiLuokkaOvi 2
#define ObjektiLuokkaNeste 3 /* versiosta 0.4.0 eteenpin nesteet ovat objekteja. Piste. */
#define ObjektiLuokkaKasvi 4
#define ObjektiLuokkaPortaat 5

#define GetObjKick 0XF     /* objektin datasta potkun tapahtuma */
#define GetObjTouch 0XF0   /* objektin datasta kosketuksen tapahtuma */
#define GetObjData 0XFF00  /* objektin datasta enginen tarvitsema data (joskus)*/

#define StTouch 0   /* Kosketetaan objektia */
#define StKick 1    /* ...ja potkitaan sit... */
#define StStand 2   /* ...ja seistn viel pll! */

/* Objektien perustapahtumat */
#define KickMurskaa 1  /* potku murskaa objektin -> poisto ilman erikoisempaa tapahtumaa */
#define KickMuuta 2    /* Potku muuttaa objektin toiseksi (linkki) */
#define KickSattuu 3   /* Potkaisijaan sattuu, eli krsii damagea */
#define KickAktivoi 4  /* Aktivoi tapahtuman data1, kutsuu spec. ksittelij */
#define KickEsine 5    /* Potkaisu tuottaa esineen! Linkki = pluokka, data1 = aliluokka */
#define KickEsine_D 6  /* Kuin ylempi, mutta tuhoutuu teon jlkeen. */

#define TouchMuuta 1    /* Kuin yll */
#define TouchAktivoi 2  /* Knn objektia - kutsutaan spec. ksittelij */
#define TouchSattuu 3   /* Kuin yll */
#define TouchEsine 4    /* Kosketus tuottaa esineen! Linkki = pluokka, data1 = aliluokka */
#define TouchMurskaa 5  /* Kuin yll */

/* piirtofunktioihin. */
#define OBJLINE_LINE 0
#define OBJLINE_RECT 1
#define OBJLINE_FILL 2

/* 
  Objektin dataan seuraavia... 
  Oletuksena objektista ei pse lpi.
*/
#define ObjLapi 0X100       /* objektista psee lpi (mutta sen lpi ei ne) */
#define ObjAuki 0X200       /* objektista psee lpi (on auki) ja sen lpi nkee */
#define ObjKimmahdus 0X400  /* objekti kimmottaa esineit (ja esim.loitsuja) */
#define ObjSwap 0X800       /* hieman oudompi... Lpinkyv, jos ollaan vieress */

#define ERKKI_LOS_LIGHT 0XFF   /* Valoisuus */
#define ERKKI_LOS_SEEN 0X100   /* Nkyyk tm pala? */

/* Muutama vakio jo valmiiksi (alioliolla) */
#define Cr_D_On        0X1
#define Cr_D_Agres     0X2
#define Cr_D_Stuck     0X4

/* Asioiden hakutermit */
#define GET_OLIO_HANDLE 0      /* Hakee tietty oliota - palauttaa ensimmisen lydetyn. */
#define GET_ESINE_HANDLE 1     /* Haetaan jotain tietty esinett - palauttaa ensimmisen lydetyn (handle). */
#define GET_OLIO_COUNT 2       /* Laskee oliot kentll (ei huomioi NPC:it/sankareita) */
#define GET_OLIO_COUNT_ALL 3   /* Laskee KAIKKI oliot kentll */
#define GET_ESINE_LOC 4        /* Haetaan jotain tietty esinett - palauttaa sijainnin. */

/* CreatureDatan, eli suora ja raaka viittaus */
#define MAIN_CREATURE 0     /* Haetaan pluokan oliolta */
#define SUB_CREATURE 1      /* Haetaan olioluokan oliolta */

#define GET_C_ELO 0         /* Olion elo (tai max. elo), pluokilla (MAIN) aina max.elo */
#define GET_C_MANA 1        /* Sama kuin yll, mutta manalle */
#define GET_C_ELOMAX 2      /* Olion elomax */
#define GET_C_MANAMAX 3     /* Sama kuin yll, mutta manalle */
#define GET_C_SLOT 4        /* Hakee varustusta */
#define GET_C_VOIMA 5       /* Suht. voimakkuus */
#define GET_C_RANGE 6       /* Nk/kuulokyky */
#define GET_C_SUOJAUS 7     /* Suht. suojaus */
#define GET_C_FLAG 8        /* Liput eli data1 */
#define GET_C_VAR 9         /* Varusteiden lukumr (max) */
#define GET_C_SLOT_I 10     /* Tietty varustelohko */
#define GET_C_MIND 11       /* Meleen min vahinko */
#define GET_C_MAXD 12       /* Meleen max vahinko */
#define GET_C_DATA 13       /* Jokin 4:st datamuuttujasta. */
#define GET_C_KUKA 14       /* SUBCREATURE:n erikoinen... palauttaa polioluokan [-...+] */

/* Varustamisen vakiot */
#define EQ_POIS 0
#define EQ_KORVAA 1

/* Oliohaun vakiot */
#define GET_VISIBLE  0
#define GET_ALL      1

/* TRIGGER-rakenteen vakiot */
/* Triggerit */
#define CLEAR_AREA 0      /* Diablotyylinen *putsaa alue*. Palauttaa OK, jos ei lainkaan olioita. */
                          /* data1: mist luokasta kaikki pit tapaa (-1: kaikki paitsi kuka) */
#define KILL_CREATURE 1   /* Tapa joku olio (viitataan Oliopalettiin, HUOM) */
#define FIND_LOCATION 2   /* Saavuta sijainti. Koordinaatti -1 = mik hyvns */
#define STAND_ON_G 3      /* Astu tietyn objektin plle. Kuka on pluokka. */

/* TriggerState palautusarvot */
#define TRIGGER_NO 0     /* Trigger kesken */
#define TRIGGER_DONE 1   /* OK */
#define TRIGGER_FAILED 2 /* Eponnistunut! */

/* 
  Activate-vakiot 
  Luomishommiin: jos sijainti ei toimi, kytetn funktiokutsun arvoja.
*/
#define ACT_SHOW_MAP          0 /* Paljastaa koko kentn */
#define ACT_KILL_CREATURE     1 /* Surmaa jonkin olion (pluokka=data1, olioista ensim. lydetyn) */
#define ACT_CREATE_OBJECT     2 /* Luo sijaintiin (data1,2) objektin (data3) */
#define ACT_HIDE_MAP          3 /* Pinvastainen show:lle :) */
#define ACT_CREATE_TRAP       4 /* Luo ansan data3 kohtaan (data1,2) */
#define ACT_CREATE_CR         5 /* Luo olion data3 (pluokka) kohtaan (data1,2) */
#define ACT_KILL_CREATURE_POS 6 /* Surmaa olion sijainnin perusteella */

/* Ansojen tapahtumavakiot */
#define TRAP_DAMAGE 0        /* Ansa vahingoittaa laukaisijaa damagella (data1-2) */
#define TRAP_HOLD 1          /* Ansa pit kiinni laukaisijasta (STACK:n dataan lippu Cr_D_Stuck plle) */
#define TRAP_KILL 2          /* Olio... kuolee. Piste. */

/* Recordin kyttmt vakiot/viestit */
#define RECD_TRAP   0        /* Ansa laukesi. data1 = olion linkki */
#define RECD_KILLED 1        /* Olio data1 kuoli (ei viel poistettu). data2 = olion pluokka */

/*
  Pelin kyttmt rakenteet.
  Muokkaa varovasti, ettei koko homma kaadu ...
*/

typedef struct ITEMSCLASS{
  signed int mika_esine, linkki; /* Esineen pluokka */
  unsigned int data1, data2;     /* Esinekohtainen data */
  unsigned int kunto;            /* Miss kunnossa esine on? */
}ITEMSCLASS;

/* Esineensilytysluokka */
typedef struct ITEMCLASS{
  signed int ylaketju, alaketju; /* Ketjutus; ala-ja ylpuolisen esineen kahva (taulukoitu ksittely) */
  ITEMSCLASS Esine;
}ITEMCLASS;

typedef struct INVENTORYCLASS{
  struct ITEMCLASS * Items;
  signed int ItemNum;
}INVENTORYCLASS;

/* Periaatteessa ei nime */
typedef struct OBJECTCLASS{
  unsigned int tyyppi; /* pvakio - mik tm on?*/
  unsigned int data;   /* Mit objektille voi tehd? Alemmat 8 bit varattu ksittelylle & potkinnalle */
  signed char ansa;
  signed linkki, data1; /* potkinnan dataa */
  signed int linkki2, data2;  /* Kosketuksen data...*/
  signed int edata; /* Ylim. data */
  signed char damage;  /* Vahinko joka tulee potkintaan/kosketukseen. Jos negat., parantaa. */
}OBJECTCLASS;

/*
  kentll oleva olio - voi olla mik hyvns!
*/

typedef struct CREATURESTACK{
  int oliotyyppi; //viittaa siihen, mit olioluokkaa on (pjako, < 0 >)
  signed int x, y; //sijainti
  signed int kx, ky; //minne menossa? jos < 0, niin ei minnekn
  signed int elo, mana;
  unsigned int liput;

  /* 8-suuntainen liikkuminen */
  signed char Motion[Max_Motion_Step]; //minne edetn - -1 = ei edet
  unsigned int * data;          /* Datalohkot */
  unsigned int * varusteet;     /* Esinefiltteri kantamiseen */
  struct CREATURESTACK * next;  /* Osoitin seuraavaan olioon (dynaaminen ksittely) */
}CREATURESTACK;

/*
  :: Infoa esineslotista ::
  Esineen nmr. on viittaus _kentn_ esineslottiin,
  jos esinelista (*inv) on NULL. Tllin olioluokan 'varastona' toimii suoraan esineluokka,
  linkkin on aseslotin nmr. Tllin aseesta saatavassa datassa kaikki liput ovat aina
  pois plt.
  Olioluokalle voi antaa toisen tilan, INVENTORYVCLASS, varaamalla sen ja kahlitsemalla
*/

/* Oliopaletti, kytetn kaikkiin olioihin */
typedef struct CREATUREPALETTE{
  char * nimi; //olion nimi
  signed int elomax, manamax;
  signed int mel1, mel2; /* Meleevahinko */
  unsigned int suojaus, voima, range;
  signed int data[MaxOlioDataNum]; /* data = vapaata dataa */
  unsigned int liput;

  signed int *filter, *varusteet, koko; //varusteet (perustavaa laatua) ja filtteri
  INVENTORYCLASS * inv;
}CREATUREPALETTE;

typedef struct KENTTABLOCK{
  unsigned char maalaatu;    /* mit maalaatua?    */
  signed int ansa;           /* onko kohta ansoitettu? <0=ei */
  signed int objekti;        /* objekti, <0=ei */
  signed int esine;          /* onko esinett <0=ei */
  signed int olio;           /* onko oliota <0 ei >=0 olio */
  unsigned int data;         /* data: valoisuus alatavu, loppu muuta */
}KENTTABLOCK;

/*
  'Raaka' esineluokka, eli tm rakenne pit sislln kaiken mahdollisen ja tarvittavan tiedon
  tietyst esineest. Esim. voi mritell esim. aseen (nimen "miekka"), ja jonka muut
  mritteet tulevat alaluokista (ITEMSCLASS), jotka saa phkill ja keksi ihan itse :)
*/
typedef struct RAW_ITEMCLASS{
  char * nimi;
  unsigned int v1, v2;               /* vahingon laskemiseen, v1 + rnd%(v2-v1) tai v1D6+v2 tms */
  signed int puolustus, hyokkays;    /* Vaikutukset nihinkin. Voi olla loitsulla esim. manankulutus */
  signed int suojaus;                /* Paljonko ase lis panssarointia? */
  signed int tehokkuus, sisassa;     /* Esineen tehokkuus (kantama, juoman teho) ja 'sisarvo' (ammus?) */
  unsigned int luokka, massa;        /* Luokka ja massa erityismrittelyyn */
  unsigned int hinta;                /* Mit tllkin nyt tekisi :) */
  unsigned int data[MaxItemDataNum]; /* Muu data (lippuina/tms)*/
}RAW_ITEMCLASS;

/* Ja trkein - itse kentt */
typedef struct KENTTA{
  unsigned int w, h; /* Kentn koko */
  unsigned int MaxCreature, MaxItem, MaxCrData, CrItems; /* Silmvarasto */
  signed int * CrFilter; //Mit varusteita oliot voivat kantaa...
  struct KENTTABLOCK *Kentta;
  struct CREATURESTACK **Oliot;
  struct ITEMCLASS *Esineet;
}KENTTA;

/* Trigger-tyyppinen tehtvrakenne */
typedef struct TRIGGER{
  unsigned int aihe;       /* Mit tehtv suoritetaan? */
  signed int kuka;         /* Kenen pit suorittaa/suoriutua (main-luokka) */
  signed int data1,data2;  /* Lisdata (esim. esineet) */
  signed int data3,data4;  /* Lisdataa */
}TRIGGER;

/* Aktivoituva tapahtuma */
typedef struct ACTIVATECLASS{
  unsigned int aihe;
  signed int data1,data2;  /* Lisdataa */
  signed int data3,data4;  /* Lisdataa */
}ACTIVATECLASS;

/* Ansat (objekteille) */
typedef struct TRAPCLASS{
  unsigned int mika_ansa;
  signed int data1,data2;  /* Lisdataa */
  signed int data3,data4;  /* Lisdataa */
}TRAPCLASS;

/*
  Funktioiden esittelyt
*/

/************************
Yleiset rutiinit
************************/
void xym_by_dir(int, int*, int*);  //palauttaa xm, ym sunnan mukaan.
void dir_by_xym(signed char *, int, int);  //antaa suunnan xm ja ym mukaan
void ERKKI_center(signed int, signed int, unsigned int, unsigned int, unsigned int, 
unsigned int, unsigned int*, unsigned int*);
signed int MiddleRand(signed int, signed int);
signed int ThrowDice(signed int, signed int, signed int);
//Mihjin suuntaan lajitellaan?
#define UPPERWAY 0
#define DOWNWAY 1
signed int SortArrayArea(signed int *, signed int, signed int, signed int);
void count_angle_move(double, double, double, double, double*, double*);
double d_abs(double);
int ERKKI_IsWear(signed int);

/*
  Kenttrutiinit
*/
void ERKKI_obj_line(KENTTA *, signed int, signed int, signed int, signed int, signed int, char);
void ERKKI_obj_pset(KENTTA *, signed int, signed int, signed int);
void ERKKI_ground_line(KENTTA *, signed int, signed int, signed int, signed int, unsigned int, char);
void ERKKI_ground_pset(KENTTA *, signed int, signed int, unsigned char);
int ERKKI_init_map(KENTTA *, int);   //alustaa kentn, maasto laitetaan annettuun arvoon...
signed int ERKKI_putdoors(KENTTA *, signed int); //asettaa ovia (luolastoon)
int ERKKI_luo_luola(KENTTA *, signed int, unsigned int, unsigned);
KENTTA * ERKKI_KENTTA(unsigned int, unsigned int, unsigned int, unsigned int, unsigned int, unsigned int, signed int *);
void ERKKI_KENTTA_free(KENTTA *);
int ERKKI_KENTTA_save(KENTTA*,FILE*);
int ERKKI_KENTTA_load(KENTTA*,FILE*);
int ERKKI_install_objects(OBJECTCLASS *);
int ERKKI_HandleMap(KENTTA *, signed int, signed int, signed int, unsigned int);
signed int ERKKI_getobject(KENTTA *, int, int);
signed int ERKKI_getmaasto(KENTTA *, int, int);
int ERKKI_objectswap(KENTTA *, signed int, signed int, unsigned int);
int ERKKI_scan_for(KENTTA *, signed int, signed int, int, signed int *, signed int *);
int ERKKI_install_traps(TRAPCLASS*);
int ERKKI_install_act(ACTIVATECLASS*);
signed int ERKKI_install_recorder(int (*f)(signed int, signed int, signed int));

/* Yleiset rutiinit, joita kytetn datan hakemiseen */
CREATURESTACK * ERKKI_AllocateCreature(KENTTA*);
CREATURESTACK * ERKKI_creature(KENTTA *, signed int);
ITEMCLASS * ERKKI_item(KENTTA *, signed int);

int ERKKI_init_creatures(KENTTA *);
int ERKKI_init_items(KENTTA *);


int ERKKI_init(unsigned int);
int ERKKI_exit();

int ERKKI_onkoeste(KENTTA*, signed int, signed int, unsigned int);

/*********************
Tehtvrutiinit
*********************/

signed int TriggerState(TRIGGER*, KENTTA*);
signed int ActivateEvent(KENTTA *, ACTIVATECLASS*, signed int, signed int);
signed int LaunchTrap(KENTTA*, TRAPCLASS*, signed int, signed int, signed int);



/* Makrot*/

/* Makro: abs. arvo ja muuta sl (tulevat mys allegrossa :P)*/
#ifndef ABS
#  define ABS(x) ((x<0)?(-(x)):(x))
#  define MIN(x, y) ((x<y)?(x):(y))
#  define MAX(x, y) ((x>y)?(x):(y))
#  define MID(x, y, z) MIN(MAX(x, y), MAX(y, z))
#endif

/* Makro: Onko piste x, y pois kentlt? */
#define NOTINMAP(kk, x, y) (x < 0 || x > kk->w - 1 || y < 0 || y > kk->h - 1)

/* Etisyyden mitta askelissa. x ja y kokonaislukuina. */
#define StepLen(xm, ym) (((xm)>(ym))?(xm):(ym))


/* Makro: objektin muokkaus */
#define WhenKick(a)  (a & 0XF)  /* Pelkk varmistus, periaatteessa... */
#define WhenTouch(a) ((a & 0XF) * (0X10))
#define GetTouch(a)  ((int)((a & GetObjTouch)/0X10))
#define GetKick(a)   (a & GetObjKick)

#endif //_ERKKI_H_