/*
  INVEN.H
  ERKKI-enginen inventoryrutiinit (eli siis esinevarastot)

  Versio 0.8.5

  Tarmo Korpela 2005
*/

#ifndef ERKKI_INVENTORY_H_
# define ERKKI_INVENTORY_H_

/* Funktiot perustavaa laatua (luominen, vapautus, alustus jne)*/
INVENTORYCLASS * ERKKI_INV(unsigned int);
void ERKKI_INV_free(INVENTORYCLASS *);
signed int CountItemsInv(INVENTORYCLASS *);
signed int FreeInvSlot(INVENTORYCLASS*);
signed int NullItemList(INVENTORYCLASS *);

/* Funktiot esineiden liikuttamiseen kentn/varaston toiseen/vlill */
int PickUpItem(KENTTA *, int, int, int, INVENTORYCLASS*);
int DropDownItem(KENTTA *, INVENTORYCLASS *, signed int, signed int, signed int);
void UnSpaceInventory(INVENTORYCLASS *);
void UnSpaceEquipInventory(KENTTA *, INVENTORYCLASS *, signed int);
signed int ERKKI_copy_in_inventory(INVENTORYCLASS *, signed int, ITEMSCLASS *);
signed int ERKKI_copy_from_inventory(INVENTORYCLASS *, signed int, ITEMSCLASS *);
signed int ERKKI_inv_to_inv(INVENTORYCLASS *, INVENTORYCLASS *, signed int);

/* Funktiot datan hakuun varastosta/olion varastosta */
signed int ScanInventory(INVENTORYCLASS *, signed int, signed int, signed int);
signed int ERKKI_GetItemDataInv(INVENTORYCLASS*, int, int, int);
signed int ERKKI_isequip(KENTTA *, signed int, signed int);

/* Muita, sekalaisia funktioita */
char * ItemNameByBlankInv(INVENTORYCLASS *, signed int);

#endif /* ERKKI_INVENTORY_H_ */