/*
  ITEM.H
  ERKKI-enginen esinerutiinit ym.

  Versio 0.8.5

  Tarmo Korpela 2005
*/

#ifndef ERKKI_ITEM_H_
# define ERKKI_ITEM_H_

/* Tarvittavat rakenteet ym ym */
#include "erkki.h"

/* 
  Esineiden definet - esineiden erotus toisistaan, tuetut esinetyypit.
*/
#define Esine_Panssari     0
#define Esine_Ase          1
#define Esine_Kilpi        2
#define Esine_Kypara       3
#define Esine_Kengat       4
#define Esine_Viitta       5
#define Esine_Vyo          6
#define Esine_Hansikkaat   7
#define Esine_Muu          8
#define Esine_Juoma        9
#define Esine_Nuoli        10
#define Esine_Kirja        11
#define Esine_Kaaro        12
#define Esine_Ruoka        13
#define Esine_Raha         14
/* Loitsu luetellaan esineeksi. Tllin sen voisi mys varustaa (hilpe idea) */
#define Esine_Loitsu       15
#define Esine_Sormus       16
#define Esine_Koru         17
/* Montako esineluokkaa yhteens */
#define Esine_Max          18

/* Mill termeill haetaan dataa esineluokista (GetItemData, ModifyItemData) */
#define GET_I_SUOJAUS   0   /* Esineen suojaus */
#define GET_I_HINTA     1   /* Esineen hinta */
#define GET_I_DATA      2   /* Esineen data */
#define GET_I_MIND      3   /* Esineen min. vahinko */
#define GET_I_MAXD      4   /* Esineen max. vahinko */
#define GET_I_TEHO      5   /* Esineen teho jos on */
#define GET_I_PAINO     6   /* Esineen massa */
#define GET_I_SIS       7   /* Esineen sislt (kirjat, krt, aseet) */
#define GET_I_LUOKKA    8   /* Esineen luokka, jos on */
#define GET_I_HYOKKAYS  9   /* Esineen hykkysbonus */
#define GET_I_PUOLUSTUS 10  /* Esineen puolustus-||- */

/* Yleiset esinefunktiot */
int ERKKI_install_items_(int, RAW_ITEMCLASS *, size_t);
#  define ERKKI_install_items(ll, dat) ERKKI_install_items_(ll, dat, sizeof(dat))
signed int CountItems(KENTTA *);
int Max_Esine(int);

/* Funktiot esineiden sijoittamiseen */
int PutItemToMap(KENTTA *, signed int, unsigned int, unsigned int);
int CopyItemToMap(KENTTA *, ITEMSCLASS *, unsigned int, unsigned int);
int MakeItemAs(KENTTA *, unsigned int, ITEMSCLASS *);
int ERKKI_getitem(KENTTA *, int, int);

/* Funktiot esineiden poistamiseen */
signed int CutItem(KENTTA *, unsigned int);
signed int DestroyItemsInLoc(KENTTA *, signed int, signed int);
signed int DestroyItem(KENTTA *, unsigned int);

/* Funktiot esineiden perusnimen mrityst varten */
char * ItemNameByHandle(KENTTA *, signed int);
char * ItemNameByBlank(signed int, signed int);
char * ItemNameByLoc(KENTTA *, signed int, signed int);
char * Item_String(signed int);

/* Funktiot esineiden etsimiseen */
signed int ItemLink(KENTTA *, int, int, int);
int FreeItemSlot(KENTTA *);
signed int GetItemByName(signed int, char *);
int ERKKI_getitem(KENTTA *, int, int);

/* Funktiot esineiden tietojen hakemiseen/muokkaukseen */
void GetMeleeDamage(signed int, signed int, signed int *, signed int *);
signed int GetItemData(signed int, signed int, signed int, signed int);
signed int ERKKI_GetItemData(KENTTA*, int, int, int);
signed int ModifyItemData(signed int, signed int, signed int, signed int, int);


#endif /* ERKKI_ITEM_H_ */